// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections

char myFlags = 0;
char uart_rd[10], buffer[20], str[17];
unsigned int index = 0, value = 0;

sbit Read at myFlags.B0;
sbit Display at myFlags.B1;

void interrupt() {

     if(OERR1_bit) {

            OERR1_bit = 0;
            CREN1_bit = 0;
            CREN1_bit = 1;
     }

     if(RC1IF_bit) {
          if((RC1REG != '0') && (Read))  {
                  uart_rd[index++] = RC1REG;
                  uart_rd[index] = '\0';

          }
          else if(RC1REG == '=') {
                Read = 1;
                index = 0;
          }
          else if(RC1REG == '0') {
                 Display = 1;
          }

          RC1IF_bit = 0;
     }
}

void main() {

     CM1CON0 = 0x00;
     CM2CON0 = 0x00;

     SLRCON = 0x00;

     ANSELA = 0x00;
     ANSELB = 0x00;
     ANSELC = 0x00;

     TRISA = 0xC0;
     TRISB = 0x00;
     TRISC = 0xC0;

     PORTA = 0x00;
     PORTB = 0x00;
     PORTC = 0x00;

     LATA = 0x00;
     LATB = 0x00;
     LATC = 0x00;

     Lcd_Init();                        // Initialize LCD
     Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
     Lcd_Cmd(_LCD_CLEAR);               // Clear display

     Lcd_Out(1,6,"Weight:");                 // Write text in first row

     UART1_Init(9615);
     Delay_ms(100);

     RC1IE_bit = 1;
     PEIE_bit = 1;
     GIE_bit = 1;
     RC1IF_bit = 0;

     while(1) {
            if(Display) {
                  LCD_Out(2,1,uart_rd);
                  Display = 0;
            }

            value = atoi(uart_rd);
     }
}